<?php
	
	/*
	WPAS File Manager v1.0
    Copyright (C) 2009 Kirill Bugvin
	
	This file is part of WPAS File Manager.
	
    WPAS File Manager is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    WPAS File Manager is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
	
	Kirill Bugvin
	kirill@bugvin.ee
	
	Bugvin Web Development OU
	http://www.bugvin.ee/
	Tallinn, Estonia
	*/
	
	$_RESULT = array();
	
	if($_GET['user_action']=='getFiles' && preg_match('/^\//', $_GET['folder'])){
		
		$folder = realURL($_GET['folder']);
		$folder = $base_dir.($folder?'/'.$folder:'');
		
		if(file_exists($folder) && is_dir($folder)){
			
			$_RESULT['base_href'] = $base_href;
			$_RESULT['path'] = substr($folder, strlen($base_dir)+1);
			$_RESULT['folders'] = array();
			$_RESULT['files'] = array();
				
				$dir = opendir($folder);
				while(false !== ($file = readdir($dir))){
					
					if($file!='.' && $file!='..'){
						
						if(is_dir($folder.'/'.$file)){
							
							$_RESULT['folders'][$file] = array(
								'size' => dirSize($folder.'/'.$file),
								'date' => filemtime($folder.'/'.$file)
							);
							
						}else{
							
							$ext = strrchr(strtolower($file), '.');
							
							//if(is_array($supported_file_types) && !in_array(substr($ext, 1), $supported_file_types)){continue;}
							
							//--------- Getting image dimensions ---------|
								
								$dimensions = false;
								
								if($ext=='.jpg' or $ext=='.jpeg' or $ext=='.gif' or $ext=='.png' or $ext=='.swf'){
									
									$tmp = getimagesize($folder.'/'.$file);
									$dimensions = $tmp[0].' x '.$tmp[1];
									
									$_RESULT['files'][$file]['dimensions'] = $dimensions;
									
									if($ext!='.swf'){
										$_RESULT['files'][$file]['icon'] = './?image_preview='.$base_href.substr($folder, strlen($base_dir)).'/'.$file;
									}
									
								}
								
							//--------- Getting image dimensions ---------|
							
							//-------- Setting file icon -------|
								
								if(!$_RESULT['files'][$file]['icon']){
									
									$_RESULT['files'][$file]['icon'] = substr($ext, 1);
									
									if(!file_exists('template/icons/'.$_RESULT['files'][$file]['icon'].'.gif')){
										$_RESULT['files'][$file]['icon'] = 'default';
									}
									
								}
								
							//-------- Setting file icon -------|
							
							$_RESULT['files'][$file]['ext'] = $ext;
							$_RESULT['files'][$file]['size'] = filesize($folder.'/'.$file);
							$_RESULT['files'][$file]['date'] = filemtime($folder.'/'.$file);
							
						}
						
					}
					
				}
				
			//ksort($_RESULT['folders']);
			//ksort($_RESULT['files']);
			
			if($_GET['sort']=='type'){
				
				if(!empty($_RESULT['folders'])){
					$_RESULT['folders'] = php_multisort(
						$_RESULT['folders'],
						array(
							array('key' => 'name', 'type' => 'string', 'sort' => 'asc')
						)
					);
				}
				
				if(!empty($_RESULT['files'])){
					$_RESULT['files'] = php_multisort(
						$_RESULT['files'],
						array(
							array('key' => 'ext', 'type' => 'string', 'sort' => 'asc'),
							array('key' => 'name', 'type' => 'string', 'sort' => 'asc')
						)
					);
				}
				
			}else if($_GET['sort']=='modified'){
				
				if(!empty($_RESULT['folders'])){
					$_RESULT['folders'] = php_multisort(
						$_RESULT['folders'],
						array(
							array('key' => 'date', 'type' => 'numeric', 'sort' => 'asc'),
							array('key' => 'name', 'type' => 'string', 'sort' => 'asc')
						)
					);
				}
				
				if(!empty($_RESULT['files'])){
					$_RESULT['files'] = php_multisort(
						$_RESULT['files'],
						array(
							array('key' => 'date', 'type' => 'numeric', 'sort' => 'asc'),
							array('key' => 'ext', 'type' => 'string', 'sort' => 'asc'),
							array('key' => 'name', 'type' => 'string', 'sort' => 'asc')
						)
					);
				}
				
			}else if($_GET['sort']=='size'){
				
				if(!empty($_RESULT['folders'])){
					$_RESULT['folders'] = php_multisort(
						$_RESULT['folders'],
						array(
							array('key' => 'size', 'type' => 'numeric', 'sort' => 'desc'),
							array('key' => 'name', 'type' => 'string', 'sort' => 'asc')
						)
					);
				}
				
				if(!empty($_RESULT['files'])){
					$_RESULT['files'] = php_multisort(
						$_RESULT['files'],
						array(
							array('key' => 'size', 'type' => 'numeric', 'sort' => 'desc'),
							array('key' => 'ext', 'type' => 'string', 'sort' => 'asc'),
							array('key' => 'name', 'type' => 'string', 'sort' => 'asc')
						)
					);
				}
				
			}else{
				
				if(!empty($_RESULT['folders'])){
					$_RESULT['folders'] = php_multisort(
						$_RESULT['folders'],
						array(
							array('key' => 'name', 'type' => 'string', 'sort' => 'asc')
						)
					);
				}
				
				if(!empty($_RESULT['files'])){
					$_RESULT['files'] = php_multisort(
						$_RESULT['files'],
						array(
							array('key' => 'name', 'type' => 'string', 'sort' => 'asc')
						)
					);
				}
				
			}
			
			if(!empty($_RESULT['files'])){
				foreach($_RESULT['files'] as $key => $val){
					$_RESULT['files'][$key]['date'] = date('Y-m-d H:i:s', $_RESULT['files'][$key]['date']);
					$_RESULT['files'][$key]['size'] = sizeMarker($_RESULT['files'][$key]['size']);
					unset($_RESULT['files'][$key]['time']);
				}
			}
			
			if(!empty($_RESULT['folders'])){
				foreach($_RESULT['folders'] as $key => $val){
					$_RESULT['folders'][$key]['date'] = date('Y-m-d H:i:s', $_RESULT['folders'][$key]['date']);
					$_RESULT['folders'][$key]['size'] = sizeMarker($_RESULT['folders'][$key]['size']);
					unset($_RESULT['folders'][$key]['time']);
				}
			}
			
			//print_r($_GET);
			//print_r($_RESULT);
			
		}else{
			
			$_RESULT['folders'] = array();
			$_RESULT['files'] = array();
			$_RESULT['path'] = '/';
			
			echo 'No such directory: '.substr(urldecode($folder), strlen($base_dir));
			
		}
		
	}else if($_GET['user_action']=='renameFile' && preg_match('/^\//', $_GET['folder']) && (!$_GET['ext'] or preg_match('/(^\.[a-zA-Z0-9]{1,15})$/', $_GET['ext']))){
		
		$folder = realURL($_GET['folder']);
		$folder = $base_dir.($folder?'/'.$folder:'');
		
		$_GET['file'] = cleanFileName($_GET['file']);
		$_GET['newName'] = cleanFileName($_GET['newName']);
		
		if(file_exists($folder.'/'.$_GET['file'].$_GET['ext'])){
			
			if(file_exists($folder.'/'.$_GET['newName'].$_GET['ext'])){
				
				$tmp_name = $folder.'/'.$_GET['newName'].$_GET['ext'];
				for($i=2;file_exists($tmp_name);$i++){
					
					$new_name = $_GET['newName'].'('.$i.')';
					$tmp_name = $folder.'/'.$new_name.$_GET['ext'];
					
				}
				
				$_GET['newName'] = $new_name;
				
			}
			
			if(rename($folder.'/'.$_GET['file'].$_GET['ext'], $folder.'/'.$_GET['newName'].$_GET['ext'])){
				
				$_RESULT['newName'] = $_GET['newName'].$_GET['ext'];
				
				if(!$_GET['ext'] or preg_match('/(jpg|jpeg|gif|png)/', $_GET['ext'])){
					
					$file_cache_folder = str_replace($base_dir, $cache_dir, $folder.'/'.$_GET['file'].$_GET['ext']);
					
					if(file_exists($file_cache_folder)){
						rename(str_replace($base_dir, $cache_dir, $folder.'/'.$_GET['file'].$_GET['ext']), str_replace($base_dir, $cache_dir, $folder.'/'.$_GET['newName'].$_GET['ext']));
					}
					
				}
				
			}else{
				echo 'Can`t rename file.';
			}
			
		}else{
			
			//echo $folder.'/'.$_GET['file'].$_GET['ext'].'<br>';
			echo 'File not found';
			
		}
		
		//print_r($_GET);
		
	}else if($_GET['user_action']=='createFolder' && preg_match('/^\//', $_GET['folder'])){
		
		$folder = realURL($_GET['folder']);
		$folder = $base_dir.($folder?'/'.$folder:'');
		
		$new_name = 'New_Folder';
		$tmp_name = $folder.'/'.$new_name;
		
		for($i=2;file_exists($tmp_name);$i++){
			
			$new_name = 'New_Folder('.$i.')';
			$tmp_name = $folder.'/'.$new_name;
			
		}
		
		if(mkdir($tmp_name)){
			$_RESULT['newName'] = $new_name;
		}
		
	}else if($_GET['user_action']=='removeFile' && preg_match('/^\//', $_GET['folder'])){
		
		$folder = realURL($_GET['folder']);
		$folder = $base_dir.($folder?'/'.$folder:'');
		
		$_GET['file'] = cleanFileName($_GET['file']);
		
		if(file_exists($folder.'/'.$_GET['file'])){
			
			if($_GET['type']=='folder'){
				
				if(deleteFolder($folder.'/'.$_GET['file'])){
					$_RESULT['fileRemoved'] = 'true';
				}
				
			}else if($_GET['type']=='file'){
				
				if(unlink($folder.'/'.$_GET['file'])){
					$_RESULT['fileRemoved'] = 'true';
				}
				
			}
			
			$file_cache_folder = str_replace($base_dir, $cache_dir, $folder.'/'.$_GET['file']);
			
			if(file_exists($file_cache_folder)){
				deleteFolder($file_cache_folder);
			}
			
		}else{
			
			echo 'File not found';
			
		}
		
		//print_r($_GET);
		
	}else if($_GET['user_action']=='archiveFile' && preg_match('/^\//', $_GET['folder'])){
		
		$folder = realURL($_GET['folder']);
		$folder = $base_dir.($folder?'/'.$folder:'');
		
		$_GET['file'] = cleanFileName($_GET['file']);
		
		if(file_exists($folder.'/'.$_GET['file'])){
			
			require('inc/pclzip.lib.php');
			
			$pos = strrpos($_GET['file'], '.');
			
			$ext = '.zip';
			$new_name = $pos!==false?substr($_GET['file'], 0, $pos):$_GET['file'];
			$tmp_name = $folder.'/'.$new_name.$ext;
			
			for($i=2;is_file($tmp_name);$i++){
				$tmp_name = $folder.'/'.$new_name.'('.$i.')'.$ext;
			}
			
			if($ext=='.zip'){
				
				$archive = new PclZip($tmp_name);
				
				if ($archive->create($folder.'/'.$_GET['file'], PCLZIP_OPT_REMOVE_PATH, $folder) == 0) {
					die('Error : '.$archive->errorInfo(true));
				}
				
			}else if($ext=='.tar.gz'){
				
				exec("cd '".$folder."'\ntar zcvf '".$tmp_name."' '".$_GET['file']."'");
				
			}
			
		}else{
			
			echo 'File not found';
			
		}
		
		//print_r($_GET);
		
	}else if($_POST['user_action']=='uploadFile' && is_array($_FILES) && preg_match('/^\//', $_POST['folder'])){
		
		$folder = realURL($_POST['folder']);
		$folder = $base_dir.($folder?'/'.$folder:'');
		
		foreach($_FILES as $index => $fileData){
			
			if(is_uploaded_file($fileData['tmp_name'])){
				
				$fileData['name'] = cleanFileName($fileData['name']);
				
				$file_size = sizeMarker($fileData['size']);
				
				$file_ext = strrchr(strtolower($fileData['name']), '.');
				$file_name = substr($fileData['name'], 0, strrpos($fileData['name'], '.'));
				
				if(is_array($supported_file_types) && !in_array(substr($file_ext, 1), $supported_file_types)){continue;}
				
				$tmp_name = $file_name;
				$tmp_src = $folder.'/'.$file_name.$file_ext;
				
				for($i=2;file_exists($tmp_src);$i++){
					
					$tmp_name = $file_name.'('.$i.')';
					$tmp_src = $folder.'/'.$tmp_name.$file_ext;
					
				}
				
				$file_name = $tmp_name;
				$file_src = $tmp_src;
				
				if(move_uploaded_file($fileData['tmp_name'], $file_src)){
					
					if($file_ext=='.jpg' or $file_ext=='.jpeg' or $file_ext=='.gif' or $file_ext=='.png'){
						
						$tmp = getimagesize($file_src);
						$dimensions = $tmp[0].' x '.$tmp[1];
						
						$icon = '/?image_preview='.$base_href.substr($folder, strlen($base_dir)).'/'.$file_name.$file_ext;
						
					}
					
					//-------- Setting file icon -------|
						
						if(!$icon){
							
							$icon = substr($file_ext, 1);
							
							if(!file_exists('template/icons/'.$icon.'.gif')){
								$icon = 'default';
							}
							
						}
						
					//-------- Setting file icon -------|
					
				}
				
				
			}
			
		}
		
		ob_end_clean();
		exit('name[:]'.$file_name.$file_ext.'[;]dimensions[:]'.$dimensions.'[;]size[:]'.$file_size.'[;]icon[:]'.$icon.'[;]date[:]'.date('Y-m-d H:i:s', filemtime($file_src)));
		
	}else if($_GET['download']=='true' && preg_match('/^\//', $_GET['folder']) && $_GET['file']){
		
		ob_end_clean();
			
			$folder = realURL($_GET['folder']);
			$folder = $base_dir.($folder?'/'.$folder:'');
			
			$_GET['file'] = cleanFileName($_GET['file']);
			
			if(file_exists($folder.'/'.$_GET['file']) && !is_dir($folder.'/'.$_GET['file'])){
				
				header( "Content-Type: application/octet-stream");
				header( "Content-Length: ".filesize($folder.'/'.$_GET['file']));
				header( "Content-Disposition: attachment; filename=".$_GET['file']);
				
				readfile($folder.'/'.$_GET['file']);
				
			}else{
				
				echo('Requested file('.$folder.'/'.$_GET['file'].') not found.');
				
			}
			
		exit();
		
	}else if($_GET['user_action']=='copy' && ($_GET['method']=='copy' or $_GET['method']=='cut') && preg_match('/^\//', $_GET['folder']) && $_GET['name'] && $_GET['place']){
		
		$_GET['name'] = cleanFileName($_GET['name']);
		
		$from_folder = realURL($_GET['folder']);
		$from_folder = $base_dir.($from_folder?'/'.$from_folder:'');
		
		$to_folder = realURL($_GET['place']);
		$to_folder = $base_dir.($to_folder?'/'.$to_folder:'');
		
		if($_GET['type']=='file' or ($_GET['folder'].($_GET['folder']!='/'?'/':'').$_GET['name'].'/'!=$_GET['place'])){
			
			if(is_dir($from_folder) && is_dir($to_folder) && $_GET['name']){
				
				if($_GET['type']=='file'){
					
					$ext = strrchr($_GET['name'], '.');
					$new_name = substr($_GET['name'], 0, strrpos($_GET['name'], '.'));
					$tmp_name = $to_folder.'/'.$new_name.$ext;
					
					for($i=2;is_file($tmp_name);$i++){
						$tmp_name = $to_folder.'/'.$new_name.'('.$i.')'.$ext;
					}
					
					if(copy($from_folder.'/'.$_GET['name'], $tmp_name)){
						
						if($_GET['method']=='cut'){
							if(unlink($from_folder.'/'.$_GET['name'])){
								if(file_exists(str_replace($base_dir, $cache_dir, $from_folder.'/'.$_GET['name']))){
									rename(str_replace($base_dir, $cache_dir, $from_folder.'/'.$_GET['name']), str_replace($base_dir, $cache_dir, $tmp_name));
								}
							}
						}
						
					}
					
				}else if($_GET['type']=='folder'){
					
					$new_name = $_GET['name'];
					$tmp_name = $to_folder.'/'.$new_name;
					
					for($i=2;is_dir($tmp_name);$i++){
						$tmp_name = $to_folder.'/'.$new_name.'('.$i.')';
					}
					
					if(copyFolder($from_folder.'/'.$_GET['name'], $tmp_name)){
						
						if($_GET['method']=='cut'){
							if(deleteFolder($from_folder.'/'.$_GET['name'])){
								if(file_exists(str_replace($base_dir, $cache_dir, $from_folder.'/'.$_GET['name']))){
									rename(str_replace($base_dir, $cache_dir, $from_folder.'/'.$_GET['name']), str_replace($base_dir, $cache_dir, $tmp_name));
								}
							}
						}
						
					}
					
				}
				
			}else{
				
				echo 'Unknown folder.';
				
			}
			
		}
		
	}else if($_GET['user_action']=='resizeImage' && preg_match('/^\//', $_GET['folder']) && $_GET['image']){
		
		$_RESULT['params'] = array();
		
		$folder = realURL($_GET['folder']);
		$folder = $base_dir.($folder?'/'.$folder:'');
		
		$_GET['image'] = cleanFileName($_GET['image']);
		
		$ext = strrchr(strtolower($_GET['image']), '.');
		
		if(($ext=='.jpg' or $ext=='.jpeg' or $ext=='.gif' or $ext=='.png') && file_exists($folder.'/'.$_GET['image'])){
			
			$src = $folder.'/'.$_GET['image'];
			$image_data = getimagesize($src);
			
			$new_image['width'] = ($_GET['x2'])?($_GET['x2']-$_GET['x']):$_GET['width'];
			$new_image['height'] = ($_GET['y2'])?($_GET['y2']-$_GET['y']):$_GET['height'];
			
			//-------------- Creating new image ---------------|
				
				if($image_data['mime']=='image/gif'){
					
					//------- GIF -------|
						
						$img = ImageCreateFromGIF($src);
						$resized = imageCreate($new_image['width'], $new_image['height']);
						
						$orange = imageColorAllocate($resized, 248, 207, 81); 
						
						imageFill($resized, 0, 0, $orange);
						imageColorTransparent($resized, $orange);
						
					//------- GIF -------|
					
				}else if($image_data['mime']=='image/png'){
					
					//------- PNG -------|
						
						$img = ImageCreateFromPNG($src);
						$resized = imageCreateTrueColor($new_image['width'], $new_image['height']);
						
						imageAlphaBlending($resized, false);
						imageSaveAlpha($resized, true);
						
					//------- PNG -------|
					
				}else if($image_data['mime']=='image/jpeg'){
					
					//------- JPEG -------|
						
						$img = ImageCreateFromJPEG($src);
						$resized = imageCreateTrueColor($new_image['width'], $new_image['height']);
						
						$white = imageColorAllocate($resized, 255, 255, 255);
						
						imageFill($resized, 0, 0, $white);
						
					//------- JPEG -------|
					
				}else{
					
					echo 'Unknown image extension';
					
				}
				
				if($img){
					
					ImageCopyResampled($resized, $img, ($_GET['x']*-1), ($_GET['y']*-1), 0, 0, $_GET['width'], $_GET['height'], $image_data[0], $image_data[1]);
					
					if(function_exists('imageantialias')){imageantialias($resized, true);}
					
					if(
						($image_data['mime']=='image/gif' && imageGIF($resized, $src))
						or
						($image_data['mime']=='image/jpeg' && imageJPEG($resized, $src))
						or
						($image_data['mime']=='image/png' && imagePNG($resized, $src))
					){
						
						$file_cache_folder = str_replace($base_dir, $cache_dir, $folder.'/'.$_GET['image']);
						
						if(file_exists($file_cache_folder)){
							deleteFolder($file_cache_folder);
						}
						
						$icon = str_replace($base_dir, $base_href, $src);
						$icon = substr($icon, 0, strrpos($icon, '/')).strrchr($icon, '/');
						
						$_RESULT['params'] = array(
							'dimensions' => $new_image['width'].' x '.$new_image['height'],
							'size' => sizeMarker(filesize($src)),
							'icon' => './?image_preview='.$icon.'&'.rand(),
							'date' => date('Y-m-d H:i:s', filemtime($src))
						);
						
					}
					
					ImageDestroy($resized);
					
				}
				
			//-------------- Creating new image ---------------|
			
		}else{
			
			echo 'File not found';
			
		}
		
	}
	
?>