<?
	/*
	WPAS File Manager v1.0
    Copyright (C) 2009 Kirill Bugvin
	
	This file is part of WPAS File Manager.
	
    WPAS File Manager is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    WPAS File Manager is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
	
	Kirill Bugvin
	kirill@bugvin.ee
	
	Bugvin Web Development OU
	http://www.bugvin.ee/
	Tallinn, Estonia
	*/
	
	
header('HTTP/1.0 200 OK');
header('Accept-Ranges: bytes');

if(!$real_file_src){exit();}

$new_width = 80;
$new_height = false;

function print_image($file){
	$image = getimagesize($file);
	header('Last-Modified: '.date('D, d M Y H:i:s', filemtime($file)));
	header('Content-type: '.$image['mime']);
	header('Content-Length: '.filesize($file));
	readfile($file);
}

$ext = strrchr(basename($real_file_src), '.');

$cache_folder = $cache_dir.substr($real_file_src, strlen($base_dir));
$cache_file = $new_width.$ext;

if($use_cache && file_exists($cache_folder.'/'.$cache_file)){
	
	print_image($cache_folder.'/'.$cache_file);
	
}else{
	
	if($use_cache && !is_dir($cache_folder)){
		
		$cache_dir = false;
		$dir_array = explode('/', $cache_folder);
		
		foreach($dir_array as $folder){
			
			if($folder){
				
				$cache_dir .= '/'.$folder;
				
				@is_dir($cache_dir);
				@mkdir($cache_dir, 0750);
				
			}
			
		}
		
		if(!is_dir($cache_folder)){
			exit('Can`t create image cache folder.');
		}
		
	}
	
	//------ Setting new image data ------|
		
		$image_data = getimagesize($real_file_src);
		
		$new_image = array();
		
		if($new_height){
			$new_image['width'] = ($new_width<$image_data[0])?$new_width:$image_data[0];
		}else if(!$new_height){
			$new_image['width'] = $new_width;
			if($image_data[0] < $new_image['width']){
				print_image($real_file_src);
				exit();
			}
		}
		
		$new_image['height'] = round($image_data[1] / $image_data[0] * $new_image['width']);
       
		if($new_image['width']==$image_data[0] && $new_image['height']==$image_data[1]){
        	print_image($real_file_src);
			exit();
		}
		
	//------ Setting new image data ------|
	
	
	//-------------- Creating new image ---------------|
		
		if($image_data['mime']=='image/gif'){
			
			//------- GIF -------|
				
				$img = ImageCreateFromGIF($real_file_src);
				$resized = imageCreate($new_image['width'], $new_image['height']);
				
				$orange = imageColorAllocate($resized, 248, 207, 81); 
				
				imageFill($resized, 0, 0, $orange);
				imageColorTransparent($resized, $orange);
				
			//------- GIF -------|
			
		}else if($image_data['mime']=='image/png'){
			
			//------- PNG -------|
				
				$img = ImageCreateFromPNG($real_file_src);
				$resized = imageCreateTrueColor($new_image['width'], $new_image['height']);
				
				imageAlphaBlending($resized, false);
				imageSaveAlpha($resized, true);
				
			//------- PNG -------|
			
		}else if($image_data['mime']=='image/jpeg'){
			
			//------- JPEG -------|
				
				$img = ImageCreateFromJPEG($real_file_src);
				$resized = imageCreateTrueColor($new_image['width'], $new_image['height']);
				
				$white = imageColorAllocate($resized, 255, 255, 255);
				
				imageFill($resized, 0, 0, $white);
				
			//------- JPEG -------|
			
		}else{
			
			exit('Unknown image type');
			
		}
		
		ImageCopyResampled($resized, $img, 0, 0, 0, 0, $new_image['width'], $new_image['height'], $image_data[0], $image_data[1]);
		ImageDestroy($img);
		
		//---------- Crop Image ------------|
			
			if($new_height){
				
				$image = imageCreateTrueColor($new_width, $new_height);
				$white = imagecolorallocate( $image, 255, 255, 255);
				
				imageFill($image, 0, 0, $white);
				
				$padding_left = ($new_image['width']<$new_width)?round(($new_width - $new_image['width']) / 2):0;
				$padding_top = round(($new_height - $new_image['height']) / 2);
				
				imagecopy($image, $resized, $padding_left, $padding_top, 0, 0, $new_image['width'], $new_image['height']);
				
				$resized = $image;
				
			}
			
		//---------- Crop Image ------------|
		
		if(function_exists('imageantialias')){imageantialias($resized, true);}
		
		if($image_data['mime']=='image/gif'){header('Content-type: image/gif');if($use_cache){imageGIF($resized, $cache_folder.'/'.$cache_file);}imageGIF($resized);}elseif
			($image_data['mime']=='image/jpeg'){header('Content-type: image/jpeg');if($use_cache){imageJPEG($resized, $cache_folder.'/'.$cache_file, 100);}imageJPEG($resized, null, 100);}elseif
				($image_data['mime']=='image/png'){header('Content-type: image/png');if($use_cache){imagePNG($resized, $cache_folder.'/'.$cache_file);}imagePNG($resized);}
		
		ImageDestroy($resized);
		
	//-------------- Creating new image ---------------|
	
}
?>