<?php
	
	/*
	WPAS File Manager v1.0
    Copyright (C) 2009 Kirill Bugvin
	
	This file is part of WPAS File Manager.
	
    WPAS File Manager is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    WPAS File Manager is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
	
	Kirill Bugvin
	kirill@bugvin.ee
	
	Bugvin Web Development OU
	http://www.bugvin.ee/
	Tallinn, Estonia
	*/
	
	Error_Reporting(E_ALL & ~E_NOTICE);
	
	ob_start();
	session_start();
	
	//------- Encoding settings ---------|
		
		header('Content-Type: text/html; charset=utf-8');
		mb_internal_encoding('UTF-8');
		setlocale(LC_ALL, array ('utf-8', 'en_US.utf8', 'ru_RU.utf8', 'et_EE.utf8'));
		
	//------- Encoding settings ---------|
	
	
	//------- Getting old session ---------|
		
		if(empty($_SESSION) && (isset($_POST['PHPSESSID']) || isset($_GET['PHPSESSID']))){
			
			$sess_id = isset($_POST['PHPSESSID'])?$_POST['PHPSESSID']:$_GET['PHPSESSID'];
			
			if(preg_match('/^([a-z0-9]{32})$/i', $sess_id)){
				
				$session_file = session_save_path().'/sess_'.$sess_id;
				
				if(is_readable($session_file)){
					session_decode(file_get_contents($session_file));
				}
				
			}
			
		}
		
	//------- Getting old session ---------|
	
	
	//-------- Requiring needed files ----------|
		
		require('inc/config.php');
		require('inc/functions.php');
		
	//-------- Requiring needed files ----------|
	
	
	//-------- Resizing requested image ---------|
		
		if(isset($_GET['image_preview']) && preg_match('/(jpg|jpeg|gif|png)$/i', $_GET['image_preview']) && preg_match('/^'.str_replace('/', '\/', quotemeta($base_href)).'/', $_GET['image_preview'])){
			
			$real_file_src = $base_dir.'/'.realURL(substr($_GET['image_preview'], strlen($base_href)));
			
			if(file_exists($real_file_src)){
				require('inc/img.php');
				exit();
			}
			
			exit('File not found.');
			
		}
		
	//-------- Resizing requested image ---------|
	
	
	//-------- Sending user words ---------|
		
		if(isset($_GET['words'])){
			
			require('inc/language.php');
			
			header('Content-Type: text/javascript');
				
				echo 'var words = {';
				
				foreach($words as $key => $value){
					
					echo '"'.addslashes($key).'":"'.addslashes($value).'",';
					
				}
				
				echo '"":""};';
				
				
			exit();
			
		}
		
	//-------- Sending user words ---------|
	
	
	//-------- Generating content ---------|
		
		if(!empty($_GET) or !empty($_POST)){
			
			require('template/js/lib/config.php');
			require('template/js/lib/JsHttpRequest.php');
			
			$JsHttpRequest = new JsHttpRequest("utf-8");
			$_RESULT = array();
			
			require('inc/answers.php');
			
		}else{
			
			require('inc/language.php');
			
			$html = file_get_contents('template/index.html');
			
			$html = str_replace('{file_types}', is_array($supported_file_types)?('*.'.implode(';*.', $supported_file_types)):'*', $html);
			$html = str_replace('{PHPSESSID}', $_REQUEST['PHPSESSID'], $html);
			
			foreach($words as $key => $val){
				$html = str_replace('{word:'.$key.'}', $val, $html);
			}
			
			echo $html;
			
		}
		
	//-------- Generating content ---------|
	
?>